Loading...
Searching...
No Matches
Sip_expires

## Data Structures

struct | sip_expires_s
| Structure for Expires header. More...

## Macros

#define | sip_expires(sip)
| Access a SIP Expires header structure sip_expires_t from sip_t.
#define | SIP_EXPIRES_INIT()
| Initializer for structure sip_expires_t.
#define | SIPTAG_EXPIRES(x)
| Tag list item for pointer to a Expires header structure sip_expires_t.
#define | SIPTAG_EXPIRES_REF(x)
| Tag list item for reference to a Expires header pointer.
#define | SIPTAG_EXPIRES_STR(s)
| Tag list item for string with Expires header value.
#define | SIPTAG_EXPIRES_STR_REF(x)
| Tag list item for reference to a Expires header string.

## Typedefs

typedef struct sip_expires_s | sip_expires_t
| @

## Functions

issize_t | sip_expires_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Expires header.
issize_t | sip_expires_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Expires header.
sip_expires_t * | sip_expires_init (sip_expires_t x[1])
| Initialize a structure sip_expires_t.
int | sip_is_expires (sip_header_t const *header)
| Test if header object is instance of sip_expires_t.
sip_expires_t * | sip_expires_dup (su_home_t *home, sip_expires_t const *hdr))
| Duplicate a list of Expires header header structures sip_expires_t.
sip_expires_t * | sip_expires_copy (su_home_t *home, sip_expires_t const *hdr))
| Copy a list of Expires header header structures sip_expires_t.
sip_expires_t * | sip_expires_make (su_home_t *home, char const *s))
| Make a Expires header structure sip_expires_t.
sip_expires_t * | sip_expires_format (su_home_t *home, char const *fmt,...)))
| Make a Expires header from formatting result.
sip_expires_t * | sip_expires_create (su_home_t *home, sip_time_t delta)
| Create an Expires header object.
sip_time_t | sip_contact_expires (sip_contact_t const *m, sip_expires_t const *ex, sip_date_t const *date, sip_time_t def, sip_time_t now)
| Calculate the expiration time for a SIP Contact.

## Variables

msg_hclass_t | sip_expires_class []
| Header class for Expires header.
tag_typedef_t | siptag_expires
| Tag for Expires header object.
tag_typedef_t | siptag_expires_str
| Tag for string with Expires header value.

## Detailed Description

## Macro Definition Documentation

## SIP_EXPIRES_INIT

#define SIP_EXPIRES_INIT | ( |  | ) |

Initializer for structure sip_expires_t.

A static sip_expires_t structure for Expires header must be initialized with the SIP_EXPIRES_INIT() macro. For instance,

sip_expires_t sip_expires = SIP_EXPIRES_INIT;
sip_expires
#define sip_expires(sip)
Access a SIP Expires header structure sip_expires_t from sip_t.
Definition sip_protos.h:4177
sip_expires_t
struct sip_expires_s sip_expires_t
@
Definition sip.h:159
SIP_EXPIRES_INIT
#define SIP_EXPIRES_INIT()
Initializer for structure sip_expires_t.
Definition sip_protos.h:4194

## SIPTAG_EXPIRES

#define SIPTAG_EXPIRES | ( |  | x | ) |

Tag list item for pointer to a Expires header structure sip_expires_t.

The SIPTAG_EXPIRES() macro is used to include a tag item with a pointer to a sip_expires_t structure in a tag list.

Parameters

  x | pointer to a sip_expires_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_EXPIRES_REF().

## SIPTAG_EXPIRES_STR

#define SIPTAG_EXPIRES_STR | ( |  | s | ) |

Tag list item for string with Expires header value.

The SIPTAG_EXPIRES_STR() macro is used to include a tag item with a string containing value of a sip_expires_t header in a tag list.

Parameters

  s | pointer to a string containing Expires header value, or NULL.

The string in SIPTAG_EXPIRES_STR() can be converted to a sip_expires_t header structure by giving the string s has second argument to function sip_expires_make().

The corresponding tag taking reference parameter is SIPTAG_EXPIRES_STR_REF().

## Typedef Documentation

## sip_expires_t

typedef struct sip_expires_s sip_expires_t

@

The Expires header field gives the date and time after which the message content expires. Its syntax is defined in RFC 3261 as follows:

Expires = "Expires" HCOLON delta-seconds

Note that the first SIP revision (RFC 2543) also allowed absolute time in Expires.

The parsed Expires header is stored in sip_expires_t structure.

The structure sip_expires_t contains representation of SIP Expires header.

The sip_expires_t is defined as follows:

typedef struct sip_expires_s {
sip_common_t ex_common[1]; // Common fragment info
sip_error_t *ex_next; // Link to next (dummy)
sip_time_t ex_date; // Seconds since Jan 1, 1900
sip_time_t ex_delta; // ...or delta seconds
} sip_expires_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_time_t
msg_time_t sip_time_t
Time in seconds since Jan 01 1900.
Definition sip.h:105
sip_expires_s
Structure for Expires header.
Definition sip.h:547
sip_expires_s::ex_date
sip_time_t ex_date
Seconds since Jan 1, 1900.
Definition sip.h:550
sip_expires_s::ex_delta
sip_time_t ex_delta
Delta seconds.
Definition sip.h:552
sip_expires_s::ex_next
sip_error_t * ex_next
Link to next (dummy).
Definition sip.h:549
sip_expires_s::ex_common
sip_common_t ex_common[1]
Common fragment info.
Definition sip.h:548

## Function Documentation

## sip_contact_expires()

sip_time_t sip_contact_expires | ( | sip_contact_t const * | m,
|  | sip_expires_t const * | ex,
|  | sip_date_t const * | date,
|  | sip_time_t | def,
|  | sip_time_t | now )

Calculate the expiration time for a SIP Contact.

Calculate expiration time of a Contact header.

Parameters

  m | Contact header
  ex | Expires header
  date | Date header
  def | default expiration time
  now | current time.

Note
  If m is NULL, the function calculates the expiration time based on the Expires and Date headers.
  If now is 0, the function gets the current time using sip_now().

Returns
  The expiration time in seconds.

## sip_expires_copy()

sip_expires_t * sip_expires_copy | ( | su_home_t * | home,
|  | sip_expires_t const * | hdr )

inline

Copy a list of Expires header header structures sip_expires_t.

The function sip_expires_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  expires = sip_expires_copy(home, sip->sip_expires);
  sip_expires_copy
  sip_expires_t * sip_expires_copy(su_home_t *home, sip_expires_t const *hdr))
  Copy a list of Expires header header structures sip_expires_t.
  Definition sip_protos.h:4324

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_expires_create()

sip_expires_t * sip_expires_create | ( | su_home_t * | home,
|  | sip_time_t | delta )

Create an Expires header object.

Create an Expires header object with the expiration time delta.

Parameters

  home | memory home used to allocate sip_expires_t structure
  delta | relative expiration time in seconds

Returns
  A pointer to newly created Expires header object when successful or NULL upon an error.

## sip_expires_dup()

sip_expires_t * sip_expires_dup | ( | su_home_t * | home,
|  | sip_expires_t const * | hdr )

inline

Duplicate a list of Expires header header structures sip_expires_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  expires = sip_expires_dup(home, sip->sip_expires);
  sip_expires_dup
  sip_expires_t * sip_expires_dup(su_home_t *home, sip_expires_t const *hdr))
  Duplicate a list of Expires header header structures sip_expires_t.
  Definition sip_protos.h:4281

Returns
  A pointer to the newly duplicated sip_expires_t header structure, or NULL upon an error.

## sip_expires_format()

sip_expires_t * sip_expires_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Expires header from formatting result.

Make a new sip_expires_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_expires_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_expires_init()

sip_expires_t * sip_expires_init | ( | sip_expires_t | x[1] | ) |

inline

Initialize a structure sip_expires_t.

An sip_expires_t structure for Expires header can be initialized with the sip_expires_init() function/macro. For instance,

sip_expires_t sip_expires;
sip_expires_init(&sip_expires);
sip_expires_init
sip_expires_t * sip_expires_init(sip_expires_t x[1])
Initialize a structure sip_expires_t.
Definition sip_protos.h:4212

## sip_expires_make()

sip_expires_t * sip_expires_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Expires header structure sip_expires_t.

The function sip_expires_make() makes a new sip_expires_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_expires_t header structure, or NULL upon an error.

## sip_is_expires()

int sip_is_expires | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_expires_t.

Check if the header class is an instance of Expires header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header expires
  0 | (false) otherwise

## Variable Documentation

## sip_expires_class

msg_hclass_t sip_expires_class[]

extern

Header class for Expires header.

The header class sip_expires_class defines how a SIP Expires header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_expires_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.